#include <iostream>
using namespace std;
int main() {

    int a = 4, b = 20;
    auto f = [&a, b] (auto x) { ++a; return a*x + b;};

    /* generated by the compiler
    struct lambda0 {
        int& a;
        const int b;
        lambda0 (int& a, int b) : a{a}, b{b} {}
        int operator() (int x) {
            ++a;  return a*x + b;
        }
    };
    lambda0 f{a, b};
    f(10) --> f.operator()(10) --> _ZN7lambda0clEi(&f, 10)
    */

    cout << "a     = " << a << endl;
    cout << "b     = " << b << endl;
    cout << "f(10) = " << f(10) << endl;
    cout << "a     = " << a << endl;
    cout << "b     = " << b << endl;

    return 0;
}
